using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using IRaCIS.Core.Domain.Share;
using Newtonsoft.Json;

namespace IRaCIS.Core.Domain.Models
{
	///<summary>
	///ReadingCriterionDictionary
	///</summary>
	[Table("ReadingSystemCriterionDictionary")]	
	 public class ReadingSystemCriterionDictionary : BaseAddAuditEntity
	 {
        #region 

        [JsonIgnore]
        [ForeignKey("DictionaryId")]
        public Dictionary Dictionary { get; set; }
        #endregion
        public Guid CriterionId { get; set; }
	

		public Guid DictionaryId { get; set; }
	



		public bool IsSystemCriterion { get; set; } = false;

		public string ParentCode { get; set; } = string.Empty;


		public bool IsBaseLineUse { get; set; } = false;


		public bool IsFollowVisitUse { get; set; } = false;

		/// <summary>
		/// ׼ֵ
		/// </summary>
		public CrterionDictionaryGroup CrterionDictionaryGroup { get; set; } = CrterionDictionaryGroup.General;


		


    }

	
}	 
