﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Test.CodeFirstTest.MSSQL.Migrations
{
    /// <inheritdoc />
    public partial class oneToManyAndOneToOne : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "SubejectVisit",
                columns: table => new
                {
                    Id = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    SubjectId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    CreateUserId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    CreateTime = table.Column<DateTime>(type: "datetime2", nullable: false),
                    UpdateUserId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    UpdateTime = table.Column<DateTime>(type: "datetime2", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_SubejectVisit", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Subject",
                columns: table => new
                {
                    Id = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    Name = table.Column<string>(type: "nvarchar(max)", nullable: false),
                    LatestSubjectVisitId = table.Column<Guid>(type: "uniqueidentifier", nullable: true),
                    FinalSubjectVisitId = table.Column<Guid>(type: "uniqueidentifier", nullable: true),
                    CreateUserId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    CreateTime = table.Column<DateTime>(type: "datetime2", nullable: false),
                    UpdateUserId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    UpdateTime = table.Column<DateTime>(type: "datetime2", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Subject", x => x.Id);
                    table.ForeignKey(
                        name: "FK_Subject_SubejectVisit_FinalSubjectVisitId",
                        column: x => x.FinalSubjectVisitId,
                        principalTable: "SubejectVisit",
                        principalColumn: "Id");
                    table.ForeignKey(
                        name: "FK_Subject_SubejectVisit_LatestSubjectVisitId",
                        column: x => x.LatestSubjectVisitId,
                        principalTable: "SubejectVisit",
                        principalColumn: "Id");
                });

            migrationBuilder.CreateIndex(
                name: "IX_SubejectVisit_SubjectId",
                table: "SubejectVisit",
                column: "SubjectId");

            migrationBuilder.CreateIndex(
                name: "IX_Subject_FinalSubjectVisitId",
                table: "Subject",
                column: "FinalSubjectVisitId");

            migrationBuilder.CreateIndex(
                name: "IX_Subject_LatestSubjectVisitId",
                table: "Subject",
                column: "LatestSubjectVisitId");

            migrationBuilder.AddForeignKey(
                name: "FK_SubejectVisit_Subject_SubjectId",
                table: "SubejectVisit",
                column: "SubjectId",
                principalTable: "Subject",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_SubejectVisit_Subject_SubjectId",
                table: "SubejectVisit");

            migrationBuilder.DropTable(
                name: "Subject");

            migrationBuilder.DropTable(
                name: "SubejectVisit");
        }
    }
}
